// Aqsis
// Copyright (c) 1997 - 2001, Paul C. Gregory
//
// Contact: pgregory@aqsis.com
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

/**
 * Copyright (C) 2006-2007  NTT DATA CORPORATION
 * 
 * Version: 1.0.0 2007/04/01
 *  
 */
package net.cellcomputing.himawari.library;

/**
 * @author NTT DATA Corporation
 * 񋓌^NX
 * CqStat̑m_intVars[]indexɗp
 */
public strictfp class EqIntIndex {
	public static final int _First_int = 0;

    // GPrim stats

	public static final int GPR_allocated 		= 1;
	public static final int GPR_created 			= 2;
	public static final int GPR_created_total 	= 3;
	public static final int GPR_current 			= 4;
	public static final int GPR_peak 				= 5;
	public static final int GPR_culled 			= 6;

    // GPrim types

	public static final int GPR_nurbs 			= 7;
	public static final int GPR_poly 				= 8;
	public static final int GPR_subdiv 			= 9;
	public static final int GPR_crv 				= 10;
	public static final int GPR_points 			= 11;
	public static final int GPR_quad 				= 12;
	public static final int GPR_patch 			= 13;

    // Geometry stats

    // Curve stats

	public static final int GEO_crv_splits 		= 14;
	public static final int GEO_crv_crv 			= 15;
	public static final int GEO_crv_patch			= 16;
	public static final int GEO_crv_crv_created 	= 17;
	public static final int GEO_crv_patch_created = 18;

    // Procedural

	public static final int GEO_prc_created 		= 19;
	public static final int GEO_prc_split 		= 20;
	public static final int GEO_prc_created_dl 	= 21; // Dynamic load
	public static final int GEO_prc_created_dra 	= 22;
	public static final int GEO_prc_created_prp 	= 23;

    // Grid stats

	public static final int GRD_created 			= 24;
	public static final int GRD_culled 			= 25;
	public static final int GRD_current 			= 26;
	public static final int GRD_peak 				= 27;
	public static final int GRD_allocated 		= 28;
	public static final int GRD_deallocated 		= 29;

    //Unshaded grids
	public static final int GRD_size_4 			= 30;
	public static final int GRD_size_8 			= 31;
	public static final int GRD_size_16 			= 32;
	public static final int GRD_size_32 			= 33;
	public static final int GRD_size_64 			= 34;
	public static final int GRD_size_128			= 35;
	public static final int GRD_size_256 			= 36;
	public static final int GRD_size_g256 		= 37;

    //Shaded grids
	public static final int GRD_shd_size_4 		= 38;
	public static final int GRD_shd_size_8 		= 39;
	public static final int GRD_shd_size_16 		= 40;
	public static final int GRD_shd_size_32 		= 41;
	public static final int GRD_shd_size_64 		= 42;
	public static final int GRD_shd_size_128 		= 43;
	public static final int GRD_shd_size_256 		= 44;
	public static final int GRD_shd_size_g256 	= 45;

    // MPG stats

    //(De)Allocs
	public static final int MPG_allocated 		= 46;
	public static final int MPG_deallocated 		= 47;
	public static final int MPG_current 			= 48;
	public static final int MPG_peak 				= 49;
	public static final int MPG_culled 			= 50;
	public static final int MPG_missed 			= 51;
	public static final int MPG_trimmed			= 52;
	public static final int MPG_trimmedout 		= 53; 

    // Sample hit quote
	public static final int MPG_sample_coverage0_125 = 54;
	public static final int MPG_sample_coverage125_25 = 55;
	public static final int MPG_sample_coverage25_375 = 56;
	public static final int MPG_sample_coverage375_50 = 57;
	public static final int MPG_sample_coverage50_625 = 58;
	public static final int MPG_sample_coverage625_75 = 59;
	public static final int MPG_sample_coverage75_875 = 60;
	public static final int MPG_sample_coverage875_100 = 61;

    //Pushes
	public static final int MPG_pushed_forward 	= 62;
	public static final int MPG_pushed_down 		= 63;
	public static final int MPG_pushed_far_down 	= 64;

    // Shading stats

    // Shaderstack
	public static final int SHD_stk_push 			= 65;
	public static final int SHD_stk_pushv 		= 66;
	public static final int SHD_stk_peak 			= 67;
	public static final int SHD_stk_pop 			= 68;
	public static final int SHD_stk_release 		= 69;
	public static final int SHD_stk_dup 			= 70;
	public static final int SHD_stk_drop 			= 71;


    // Variables
	public static final int SHD_var_created_total 	= 72;		//shadercreateꂽ
	public static final int SHD_var_current 			= 73;		//ݐĂshader
	public static final int SHD_var_peak 				= 74;		//shader̍őgp

	public static final int SHD_var_array 			= 75;
	public static final int SHD_var_array_current 	= 76;
	public static final int SHD_var_array_peak 		= 77;
	public static final int SHD_var_array_init 		= 78;

    // Uniform
	public static final int SHD_var_uniform 			= 79;
	public static final int SHD_var_uniform_current 	= 80;		//ݐĂCqShaderVariableUniform
	public static final int SHD_var_uniform_peak 		= 81;		//CqShaderVariableUniformn̍őgp
	public static final int SHD_var_uniform_init 		= 82;		

	public static final int SHD_var_uniform_float 	= 83;
	public static final int SHD_var_uniform_string 	= 84;
	public static final int SHD_var_uniform_point 	= 85;
	public static final int SHD_var_uniform_vector 	= 86;
	public static final int SHD_var_uniform_normal 	= 87;
	public static final int SHD_var_uniform_color 	= 88;
	public static final int SHD_var_uniform_matrix 	= 89;

    // Varying
	public static final int SHD_var_varying		 	= 90;
	public static final int SHD_var_varying_current 	= 91;
	public static final int SHD_var_varying_peak 		= 92;
	public static final int SHD_Var_varying_init 		= 93;

	public static final int SHD_var_varying_float 	= 94;
	public static final int SHD_var_varying_string 	= 95;
	public static final int SHD_var_varying_point 	= 96;
	public static final int SHD_var_varying_vector 	= 97;
	public static final int SHD_var_varying_normal 	= 98;
	public static final int SHD_var_varying_color 	= 99;
	public static final int SHD_var_varying_matrix 	= 100;

    // Per-shadeop stats
	public static final int SHD_so_abs 				= 101;
	public static final int SHD_so_acos 				= 102;
	public static final int SHD_so_ambient 			= 103;
	public static final int SHD_so_area 				= 104;
	public static final int SHD_so_asin 				= 105;
	public static final int SHD_so_atan 				= 106;
	public static final int SHD_so_atmosphere 		= 107;
	public static final int SHD_so_attribute 			= 108;
	public static final int SHD_so_bake 				= 109;
	public static final int SHD_so_bump 				= 110;
	public static final int SHD_so_cDeriv 			= 111;
	public static final int SHD_so_cDu 				= 112;
	public static final int SHD_so_cDv 				= 113;
	public static final int SHD_so_calculatenormal 	= 114;
	public static final int SHD_so_ccellnoise1 		= 115;
	public static final int SHD_so_ccellnoise2 		= 116;
	public static final int SHD_so_ccellnoise3 		= 117;
	public static final int SHD_so_ccellnoise4 		= 118;
	public static final int SHD_so_ceil 				= 119;
	public static final int SHD_so_cenvironment2 		= 120;
	public static final int SHD_so_cenvironment3 		= 121;
	public static final int SHD_so_cclamp 			= 122;
	public static final int SHD_so_clamp 				= 123;
	public static final int SHD_so_cmax 				= 124;
	public static final int SHD_so_cmin 				= 125;
	public static final int SHD_so_cmix 				= 126;
	public static final int SHD_so_cnoise1 			= 127;
	public static final int SHD_so_cnoise2 			= 128;
	public static final int SHD_so_cnoise3 			= 129;
	public static final int SHD_so_cnoise4 			= 130;
	public static final int SHD_so_concat 			= 131;
	public static final int SHD_so_cos 				= 132;
	public static final int SHD_so_cpnoise1 			= 133;
	public static final int SHD_so_cpnoise2 			= 134;
	public static final int SHD_so_cpnoise3 			= 135;
	public static final int SHD_so_cpnoise4 			= 136;
	public static final int SHD_so_crandom 			= 137;
	public static final int SHD_so_cspline			= 138;
	public static final int SHD_so_csplinea 			= 139;
	public static final int SHD_so_ctexture1 			= 140;
	public static final int SHD_so_ctexture2 			= 141;
	public static final int SHD_so_ctexture3 			= 142;
	public static final int SHD_so_ctransform 		= 143;
	public static final int SHD_so_degrees 			= 144;
	public static final int SHD_so_depth 				= 145;
	public static final int SHD_so_determinant 		= 146;
	public static final int SHD_so_diffuse 			= 147;
	public static final int SHD_so_displacement 		= 148;
	public static final int SHD_so_distance 			= 149;
	public static final int SHD_so_exp 				= 150;
	public static final int SHD_so_external 			= 151;
	public static final int SHD_so_fDeriv 			= 152;
	public static final int SHD_so_fDu 				= 153;
	public static final int SHD_so_fDv 				= 154;
	public static final int SHD_so_faceforward 		= 155;
	public static final int SHD_so_faceforward2 		= 156;
	public static final int SHD_so_fcellnoise1 		= 157;
	public static final int SHD_so_fcellnoise2 		= 158;
	public static final int SHD_so_fcellnoise3 		= 159;
	public static final int SHD_so_fcellnoise4 		= 160;
	public static final int SHD_so_fenvironment2 		= 161;
	public static final int SHD_so_fenvironment3 		= 162;
	public static final int SHD_so_filterstep 		= 163;
	public static final int SHD_so_filterstep2 		= 164;
	public static final int SHD_so_floor 				= 165;
	public static final int SHD_so_fmix 				= 166;
	public static final int SHD_so_fnoise1 			= 167;
	public static final int SHD_so_fnoise2 			= 168;
	public static final int SHD_so_fnoise3 			= 169;
	public static final int SHD_so_fnoise4 			= 170;
	public static final int SHD_so_format 			= 171;
	public static final int SHD_so_fpnoise1 			= 172;
	public static final int SHD_so_fpnoise2			= 173;
	public static final int SHD_so_fpnoise3 			= 174;
	public static final int SHD_so_fpnoise4 			= 175;
	public static final int SHD_so_frandom 			= 176;
	public static final int SHD_so_fresnel 			= 177;
	public static final int SHD_so_fspline 			= 178;
	public static final int SHD_so_fsplinea 			= 179;
	public static final int SHD_so_ftexture1 			= 180;
	public static final int SHD_so_ftexture2 			= 181;
	public static final int SHD_so_ftexture3 			= 182;
	public static final int SHD_so_illuminance		= 183;
	public static final int SHD_so_illuminate 		= 184;
	public static final int SHD_so_incident 			= 185;
	public static final int SHD_so_inversesqrt 		= 186;
	public static final int SHD_so_length 			= 187;
	public static final int SHD_so_lightsource 		= 188;
	public static final int SHD_so_log 				= 189;
	public static final int SHD_so_match 				= 190;
	public static final int SHD_so_max 				= 191;
	public static final int SHD_so_min 				= 192;
	public static final int SHD_so_mod 				= 193;
	public static final int SHD_so_mrotate 			= 194;
	public static final int SHD_so_mscale 			= 195;
	public static final int SHD_so_mtranslate			= 196;
	public static final int SHD_so_normalize		 	= 197;
	public static final int SHD_so_ntransform 		= 198;
	public static final int SHD_so_occlusion 			= 199;
	public static final int SHD_so_opposite 			= 200;
	public static final int SHD_so_option 			= 201;
	public static final int SHD_so_pDeriv 			= 202;
	public static final int SHD_so_pDu 				= 203;
	public static final int SHD_so_pDv 				= 204;
	public static final int SHD_so_pcellnoise1 		= 205;
	public static final int SHD_so_pcellnoise2 		= 206;
	public static final int SHD_so_pcellnoise3 		= 207;
	public static final int SHD_so_pcellnoise4 		= 208;
	public static final int SHD_so_pclamp 			= 209;
	public static final int SHD_so_phong 				= 210;
	public static final int SHD_so_pmax 				= 211;
	public static final int SHD_so_pmin 				= 212;
	public static final int SHD_so_pmix 				= 213;
	public static final int SHD_so_pnoise1 			= 214;
	public static final int SHD_so_pnoise2 			= 215;
	public static final int SHD_so_pnoise3 			= 216;
	public static final int SHD_so_pnoise4 			= 217;
	public static final int SHD_so_pow 				= 218;
	public static final int SHD_so_ppnoise1 			= 219;
	public static final int SHD_so_ppnoise2 			= 220;
	public static final int SHD_so_ppnoise3 			= 221;
	public static final int SHD_so_ppnoise4 			= 222;
	public static final int     SHD_so_prandom 		= 223;
	public static final int SHD_so_printf 			= 224;
	public static final int SHD_so_pspline 			= 225;
	public static final int SHD_so_psplinea 			= 226;
	public static final int SHD_so_ptlined 			= 227;
	public static final int SHD_so_radians 			= 228;
	public static final int SHD_so_reflect 			= 229;
	public static final int SHD_so_refract 			= 230;
	public static final int SHD_so_rendererinfo 		= 231;
	public static final int SHD_so_rotate 			= 232;
	public static final int SHD_so_round 				= 233;
	public static final int SHD_so_scspline 			= 234;
	public static final int SHD_so_scsplinea 			= 235;
	public static final int SHD_so_setcomp 			= 236;
	public static final int SHD_so_setmcomp 			= 237;
	public static final int SHD_so_setxcomp 			= 238;
	public static final int SHD_so_setycomp 			= 239;
	public static final int SHD_so_setzcomp 			= 240;
	public static final int SHD_so_sfspline 			= 241;
	public static final int SHD_so_sfsplinea 			= 242;
	public static final int SHD_so_shadername 		= 243;
	public static final int SHD_so_shadername2 		= 244;
	public static final int SHD_so_shadow 			= 245;
	public static final int SHD_so_shadow1 			= 246;
	public static final int SHD_so_sign 				= 247;
	public static final int SHD_so_sin 				= 248;
	public static final int SHD_so_smoothstep 		= 249;
	public static final int SHD_so_solar 				= 250;
	public static final int SHD_so_specular 			= 251;
	public static final int SHD_so_specularbrdf 		= 252;
	public static final int SHD_so_spspline 			= 253;
	public static final int SHD_so_spsplinea 			= 254;
	public static final int SHD_so_sqrt 				= 255;
	public static final int SHD_so_step 				= 256;
	public static final int SHD_so_surface 			= 257;
	public static final int SHD_so_tan 				= 258;
	public static final int SHD_so_textureinfo 		= 259;
	public static final int SHD_so_trace 				= 260;
	public static final int SHD_so_transform 			= 261;
	public static final int SHD_so_vmix 				= 262;
	public static final int SHD_so_vtransform 		= 263;
    // Sampling stats

	public static final int SPL_count 				= 264;
	public static final int SPL_bound_hits 			= 265;
	public static final int SPL_hits 					= 266;

    // Parameters
	public static final int PRM_created 				= 267;
	public static final int PRM_current 				= 268;
	public static final int PRM_peak 					= 269;

	public static final int _Last_int 				= 270;
	
	private int value;

	public int getValue()
	{
		return value;
	}
	public void setValue(int val)
	{
		value = val;
	}
}
